
/**
 * Created by IntelliJ IDEA.
 * Creator: Brigitte Andrich (bandrich@cosy.sbg.ac.at)
 * MatNr.: 9920241
 * Date: 08.06.2003
 * Time: 10:33:01
 * Klasse ist nur eine Hilfsklasse zum Starten des Coders und der Decoders.
 * Auch um leichter ersichtlich zu machen wie die Wavelet2DCoder Klasse zu verwenden ist.
 */
/* sollte nach Wavelet2DCoder.main() wandern, Rade */
public class CoderStart {

    /**
     * S: Eingangssignal fr Coder
     */
    public static Signal2D S = new Signal2D(new Position(16, 16));
    /**
     * Q: Quantisiertes Ausgangssignal von Coder und Eingangssignal fr Decoder
     */
    public static Quantized2D Q = new Quantized2D(new Position(16, 16));
    /**
     * D: Dequantisiertes Ausgangssignal von Decoder
     */
    public static Signal2D D = new Signal2D(new Position(16, 16));

    public static void main(String args[]) {
        initializeMatrix();
        //Erster Parameter gibt die Tiefe an, zweiter P. den Quantisierungsfaktor
        Wavelet2DCoder myCoder = new Wavelet2DCoder(3, 2);
        //Dem Coder muss das Eingangssignal bergeben werden, dass zurzeit so aussieht,
        //wie nach der WaveletTransformation
        Q = myCoder.encode(S);
        //Dem Decoder ist das quantisierte Signal mitzugeben und die Predictor-Koeffizienten
        D = myCoder.decode(Q, myCoder.getCoeffArray());
    }

    /**
     * Naja, behelfsmig zum initialisieren des Eingangssignals
     */
    private static void initializeMatrix() {
        for (int i = 0; i < 2; i++) {
            S.Set(new Position(0, i), 0.0);
            S.Set(new Position(1, i), 0.0);
            S.Set(new Position(2, i), 1.0);
            S.Set(new Position(3, i), 1.0);
            S.Set(new Position(4, i), 4.0);
            S.Set(new Position(5, i), 4.0);
            S.Set(new Position(6, i), 4.0);
            S.Set(new Position(7, i), 4.0);
            for (int j = 8; j < 16; j++) {
                S.Set(new Position(j, i), 7.0);
            }
        }

        for (int i = 2; i < 4; i++) {
            S.Set(new Position(0, i), 2.0);
            S.Set(new Position(1, i), 2.0);
            S.Set(new Position(2, i), 3.0);
            S.Set(new Position(3, i), 3.0);
            S.Set(new Position(4, i), 4.0);
            S.Set(new Position(5, i), 4.0);
            S.Set(new Position(6, i), 4.0);
            S.Set(new Position(7, i), 4.0);
            for (int j = 8; j < 16; j++) {
                S.Set(new Position(j, i), 7.0);
            }
        }

        for (int i = 4; i < 8; i++) {
            S.Set(new Position(0, i), 5.0);
            S.Set(new Position(1, i), 5.0);
            S.Set(new Position(2, i), 5.0);
            S.Set(new Position(3, i), 5.0);
            S.Set(new Position(4, i), 6.0);
            S.Set(new Position(5, i), 6.0);
            S.Set(new Position(6, i), 6.0);
            S.Set(new Position(7, i), 6.0);
            for (int j = 8; j < 16; j++) {
                S.Set(new Position(j, i), 7.0);
            }
        }

        for (int i = 8; i < 16; i++) {
            for (int j = 0; j < 8; j++)
                S.Set(new Position(j, i), 8.0);
            for (int j = 8; j < 16; j++) {
                S.Set(new Position(j, i), 9.0);
            }
        }
    }
}
