abstract class Double1DArray
{
  abstract double Get (int n);

  abstract void Set (int n, double v);

  abstract int Length ();

  void SetAll (double v)
  {
    for (int i = 0; i < Length (); i ++)
        Set (i, v);
  }

  void CopyFrom (Double1DArray From)
  {
    for (int i = 0; i < Length (); i ++)
        Set (i, From.Get (i));
  }

  void CopyTo (Double1DArray To)
  {
    for (int i = 0; i < Length (); i ++)
        To.Set (i, Get (i));
  }

  void Print ()
  {
    System.out.print ("(");
    for (int i = 0; i < Length (); i ++)
    {   if (i > 0) System.out.print (", ");
        System.out.print (Get (i));
    }
    System.out.println (")");
  }

  public double SSE (Double1DArray S)
  {
    double SE = 0.0;
    for (int i = 0; i < Length (); i ++)
    {   double E = S.Get (i) - Get (i);
        SE += E * E;
    }
    return SE;
  }

  public double MSE (Double1DArray S)
  {
    return SSE (S) / (double) Length ();
  }

  public double PSNR (Double1DArray S, double max)
  {
    return 10.0 * Math.log (max * max / MSE (S)) / Math.log (10);
  }
}
