abstract class Int2DArray
{
  abstract int Get (Position p);

  abstract void Set (Position p, int v);

  abstract Position Dimension ();

  int Size ()
  { return Dimension ().X () * Dimension ().Y (); }

  void SetAll (int v)
  {
    for (PositionIterator i = new PositionIterator (Dimension ()); ! i.AtEnd (); i.Iterate ())
        Set (i.Current (), v);
  }

  void Print ()
  {
    for (int i = 0; i < Dimension ().Y (); i ++)
        new IntRow (this, i).Print ();
  }

  int AbsMax ()
  {
    int max = 0;
    for (PositionIterator i = new PositionIterator (Dimension ()); ! i.AtEnd (); i.Iterate ())
        if (max < Math.abs (Get (i.Current ())))
           max = Math.abs (Get (i.Current ()));
    return max;
  }
}
