class Predictor extends Double1DArray
{
  private double Coeffs[];

  Predictor (int CoeffCount)
  {
    Coeffs = new double[CoeffCount];
  }

  public double Get (int n)
  {
    return Coeffs[n];
  }

  public void Set (int n, double v)
  {
    Coeffs[n] = v;
  }

  public int Length ()
  {
    return Coeffs.length;
  }

  double Predict (Double1DArray S)
  {
    double P = 0.0;
    for (int i = 0; i < Length (); i ++)
        P += Get (i) * S.Get (i);
    return P;
  }

  public static void main (String[] args)
  {
    Signal1D S = new Signal1D (3);
    S.Set (0, 1.5);
    S.Set (1, 2.5);
    S.Set (2, 3.5);
    Predictor P = new Predictor (3);
    P.Set (0, 0.33);
    P.Set (1, 0.33);
    P.Set (2, 0.33);
    System.out.println (P.Predict (S));
  }
}

