class Quantized2D extends Int2DArray
{
  private int Samples[][];

  Quantized2D (Position Dim)
  {
    Samples = new int[Dim.Y ()][Dim.X ()];
  }

  int Get (Position p)
  {
    return Samples[p.Y ()][p.X ()];
  }

  void Set (Position p, int v)
  {
    Samples[p.Y ()][p.X ()] = v;
  }

  Position Dimension ()
  {
    return new Position (Samples[0].length, Samples.length);
  }

  public void Quantize (Double2DArray S, double delta)
  {
    double q = 1.0 / delta;
    Position p = new Position(0,0);
    for (int i = 0; i < Dimension ().X (); i ++)
    {
      for (int j = 0; j < Dimension ().Y (); j ++)
      {
        p = new Position(i,j);
        Set(p, (int) Math.round (S.Get(p) * q));
      }
    }
  }

  public void Dequantize (Double2DArray S, double delta)
  {
    Position p = new Position(0,0);
    for (int i = 0; i < Dimension ().X (); i ++)
    {
      for (int j = 0; j < Dimension ().Y (); j ++)
      {
        p = new Position(i,j);
        if (Get(p) >= 0)
             S.Set (p, (double) Get(p) * delta);
        else S.Set (p, (double) Get(p) * delta);
      }
    }
  }

  public static void main (String[] args)
  {
     Quantized2D S = new Quantized2D (new Position (2, 3));
     S.Set (new Position (0, 0), 1);
     S.Set (new Position (1, 0), 2);
     S.Set (new Position (0, 1), 3);
     S.Set (new Position (1, 1), 4);
     S.Set (new Position (0, 2), 5);
     S.Set (new Position (1, 2), 6);
     S.Print ();
  }

}
